#include "LedControl.h"
#include <SPI.h>

LedControl lc=LedControl(11,13,10,4);  // Pins: DIN,CLK,CS, # of Display connected

unsigned long delayTime=200;  // Delay between Frames

int dNote = 8;
int eNote = 7;
int fNote = 6;
int gNote = 5;
int aNote = 4;
int bNote = 3;
int Piezo = 2;

int Record = 9;
int Play = 12;

double d = 293.66;// the frequency of note d
double e = 329.63;// the frequency of note e
double f = 349.23;// the frequency of note f
double g = 392;// the frequency of note g
double a = 440;// the frequency of note a
double b = 493.88;// the frequency of note b

double song[200];
int iterator = 0;
int rec = 0;


// Put values in arrays
byte invader1a[] =
{
   B00011000,  // First frame of invader #1
   B00111100,
   B01111110,
   B11011011,
   B11111111,
   B00100100,
   B01011010,
   B10100101
};

byte invader1b[] =
{
  B00011000, // Second frame of invader #1
  B00111100,
  B01111110,
  B11011011,
  B11111111,
  B00100100,
  B01011010,
  B01000010
};

byte invader2a[] =
{
  B00100100, // First frame of invader #2
  B00100100,
  B01111110,
  B11011011,
  B11111111,
  B11111111,
  B10100101,
  B00100100
};

byte invader2b[] =
{
  B00100100, // Second frame of invader #2
  B10100101,
  B11111111,
  B11011011,
  B11111111,
  B01111110,
  B00100100,
  B01000010
};

byte invader3a[] =
{
   B00011000,  // First frame of invader #1
   B00111100,
   B01111110,
   B11011011,
   B11111111,
   B00100100,
   B01011010,
   B10100101
};

byte invader3b[] =
{
  B00011000, // Second frame of invader #1
  B00111100,
  B01111110,
  B11011011,
  B11111111,
  B00100100,
  B01011010,
  B01000010
};

byte invader4a[] =
{
  B00100100, // First frame of invader #2
  B00100100,
  B01111110,
  B11011011,
  B11111111,
  B11111111,
  B10100101,
  B00100100
};

byte invader4b[] =
{
  B00100100, // Second frame of invader #2
  B10100101,
  B11111111,
  B11011011,
  B11111111,
  B01111110,
  B00100100,
  B01000010
};

void setup()
{
  lc.shutdown(0,false);  // Wake up displays
  lc.shutdown(1,false);
  lc.shutdown(2,false);
  lc.shutdown(3,false);
  lc.setIntensity(0,5);  // Set intensity levels
  lc.setIntensity(1,5);
  lc.setIntensity(2,5);
  lc.setIntensity(3,5);
  lc.clearDisplay(0);  // Clear Displays
  lc.clearDisplay(1);
  lc.clearDisplay(2);
  lc.clearDisplay(3);

  pinMode(dNote, INPUT);
  pinMode(eNote, INPUT);
  pinMode(fNote, INPUT);
  pinMode(gNote, INPUT);
  pinMode(aNote, INPUT);
  pinMode(bNote, INPUT);
  pinMode(Record, INPUT);
  pinMode(Play, INPUT);
  pinMode(Piezo, OUTPUT);
  Serial.begin(9600);

}


//  Take values in Arrays and Display them
void sinvader1a()
{
  for (int i = 0; i < 8; i++)  
  {
    lc.setRow(0,i,invader1a[i]);
  }
}

void sinvader1b()
{
  for (int i = 0; i < 8; i++)
  {
    lc.setRow(0,i,invader1b[i]);
  }
}

void sinvader2a()
{
  for (int i = 0; i < 8; i++)
  {
    lc.setRow(1,i,invader2a[i]);
  }
}

void sinvader2b()
{
  for (int i = 0; i < 8; i++)
  {
    lc.setRow(1,i,invader2b[i]);
  }
}

void sinvader3a()
{
  for (int i = 0; i < 8; i++)  
  {
    lc.setRow(2,i,invader1a[i]);
  }
}

void sinvader3b()
{
  for (int i = 0; i < 8; i++)
  {
    lc.setRow(2,i,invader1b[i]);
  }
}

void sinvader4a()
{
  for (int i = 0; i < 8; i++)
  {
    lc.setRow(3,i,invader2a[i]);
  }
}

void sinvader4b()
{
  for (int i = 0; i < 8; i++)
  {
    lc.setRow(3,i,invader2b[i]);
  }
}

void loop()
{

   if (digitalRead(Record) == 1) {
    if (rec == 0)
      rec = 1;
    else if (rec == 1)
      rec = 0;
    delay(200);
  } else if (digitalRead(dNote) == 1) {
    sinvader2b();
    sinvader1b();
    tone(Piezo, d, 250);  // plays note d
    delay(200);
    
    if (rec == 1) {
      song[iterator] = d;
      iterator += 1;
    }
    
  }else if (digitalRead(eNote) == 1) {
    sinvader3b();
    tone(Piezo, e, 250);  // plays note e
    delay(200);
    
    if (rec == 1) {
      song[iterator] = e;
      iterator += 1;
    }
    
  }else if (digitalRead(fNote) == 1) {
    sinvader4b();
    tone(Piezo, f, 250);  // plays note f
    delay(200);
    
    if (rec == 1) {
      song[iterator] = f;
      iterator += 1;
    }
    
  }else if (digitalRead(gNote) == 1) {
    sinvader2b();
    tone(Piezo, g, 250);  // plays note g
    delay(200);
    
    if (rec == 1) {
      song[iterator] = g;
      iterator += 1;
    }
    
  }else if (digitalRead(aNote) == 1) {
    sinvader2b();
    tone(Piezo, a, 250);  // plays note a
    delay(200);
    
    if (rec == 1) {
      song[iterator] = a;
      iterator += 1;
    }
    
  }else if (digitalRead(bNote) == 1) {
    sinvader3b();
    tone(Piezo, b, 250);  // plays note b
    delay(200);
    
    if (rec == 1) {
      song[iterator] = b;
      iterator += 1;
    }
    
  }else if (digitalRead(Play) == 1) {
    int i;
    
    for (i = 0; i < iterator; i += 1) {
      tone(Piezo, song[i], 250);
      delay(500);
      if (i % 4 == 0) { 
        sinvader1b();
        sinvader2a();
        sinvader3a();
        sinvader4a();
      }
      else if (i % 4 == 1) {
        sinvader1a();
        sinvader2b();
        sinvader3a();
        sinvader4a();
      }
      else if (i % 4 == 2) {
        sinvader1a();
        sinvader2a();
        sinvader3b();
        sinvader4a();
        }
      else {
        sinvader1a();
        sinvader2a();
        sinvader3a();
        sinvader4b();
      }
    }
    iterator = 0;
    
  }
  else {
    noTone(Piezo);
  }
    sinvader1a();
    sinvader2a();
    sinvader3a();
    sinvader4a();


}
